#define DLL_EXPORT   

#ifndef _DLL_TUTORIAL_H_
    #define _DLL_TUTORIAL_H_
    #include <iostream>
     
    #if defined DLL_EXPORT
      #define DECLDIR __declspec(dllexport)
    #else
      #define DECLDIR __declspec(dllimport)
    #endif
     
    extern "C"
    {

        DECLDIR void FA_LEDWrite( unsigned char value );
        DECLDIR void FA_LEDOn( unsigned char index );
        DECLDIR void FA_LEDOff( unsigned char index );
        DECLDIR unsigned char FA_ReadSwitch( unsigned char index );
        //DECLDIR unsigned char FA_WaitSwitch( unsigned char a );
        DECLDIR void FA_SetMotors( signed int left, signed int right );
        DECLDIR unsigned int FA_ReadIR( unsigned char index );
        DECLDIR unsigned int FA_ReadLine( unsigned char index );
        DECLDIR unsigned int FA_ReadLight();
        DECLDIR void FA_Forwards(unsigned int distance);
        DECLDIR void FA_Backwards(unsigned int distance);
        DECLDIR void FA_Left(unsigned int angle);
        DECLDIR void FA_Right(unsigned int angle);
        DECLDIR void FA_SetLogoSpeed(unsigned char speed);
        DECLDIR void FA_EncoderReset(void);
        DECLDIR unsigned int FA_EncoderRead(unsigned char index);
        DECLDIR void FA_LCDClear(void);
        DECLDIR void FA_LCDPrintString(unsigned char x, unsigned char y, unsigned char * text);
        DECLDIR void FA_LCDPrintNumber(unsigned char x, unsigned char y, signed int number);
        DECLDIR void FA_LCDDrawPixel(unsigned char x, unsigned char y, unsigned char state);
        DECLDIR void FA_LCDDrawLine(unsigned char x1, unsigned char y1, unsigned char x2, unsigned char y2);
        DECLDIR void FA_LCDDrawRect(unsigned char x1, unsigned char y1, unsigned char x2, unsigned char y2, unsigned char transparent, unsigned char solid);
        DECLDIR void FA_LCDBacklight(unsigned char value);
        DECLDIR void FA_LCDVerbose(unsigned char value);
        DECLDIR unsigned int FA_ReadMic(void);
        DECLDIR void FA_PlayNote(unsigned int note, unsigned int time);
		
		DECLDIR void FA_ServoEnable(unsigned char index);
		DECLDIR void FA_ServoDisable(unsigned char index);
		DECLDIR void FA_ServoSetPosition(unsigned char index, unsigned char position);
		DECLDIR void FA_ServoAutoMoveToPosition(unsigned char index, unsigned char position);
		DECLDIR void FA_ServoSetAutoMoveSpeed(unsigned char speed);
		
		DECLDIR unsigned char FA_CardInit( void );
		DECLDIR unsigned char FA_CardCreate( unsigned char * filename );
		DECLDIR unsigned char FA_CardOpen( unsigned char * filename );
		DECLDIR unsigned char FA_CardDelete( unsigned char * filename );
		DECLDIR void FA_CardWriteByte( unsigned char data );
		DECLDIR unsigned char FA_CardReadByte( void );
		DECLDIR unsigned char FA_CardRecordMic( unsigned char bitdepth, unsigned int samplerate, unsigned int time, unsigned char * filename);
		DECLDIR unsigned char FA_CardPlayback(unsigned char * filename);
		DECLDIR unsigned char FA_CardBitmap(unsigned char x, unsigned char y, unsigned char * filename);
		
		DECLDIR signed int FA_ReadAxis(unsigned char index);
		DECLDIR unsigned int FA_ReadBearing( void );
		
		DECLDIR unsigned char FA_ComFindFirst( void );
		DECLDIR unsigned char FA_ComQuery( char port );
		DECLDIR unsigned char FA_ComOpen( char port );
		DECLDIR unsigned char FA_ComClose( void );
		
		static void BaudRateSet( unsigned long Baud );
		static unsigned int ReadCharCOM( unsigned int timeout, unsigned int timeout_val );
		static void SendCharCOM( unsigned char Data );
		static void SetDTRState( unsigned char state );
		static void SetFlowControl( unsigned char state );

    }
     
 #endif
 
 